VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Follow the Yellow Brick Road"
   ClientHeight    =   2625
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5055
   BeginProperty Font 
      Name            =   "Georgia"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   175
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   337
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrEnd 
      Enabled         =   0   'False
      Interval        =   2500
      Left            =   600
      Top             =   120
   End
   Begin VB.Timer tmrSayStuff 
      Interval        =   100
      Left            =   120
      Top             =   120
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim worldMap() As Integer
Dim blnLeftDown As Boolean, blnRightDown As Boolean, blnUpDown As Boolean, blnDownDown As Boolean
Dim strMessage As String
Dim intObtained As Integer
Dim X As Single, Y As Single
Dim intLastMessage As Integer
Dim dblLastMessage As Double

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyEscape
            End
        Case vbKeyLeft, vbKeyA
            blnLeftDown = True
        Case vbKeyRight, vbKeyD
            blnRightDown = True
        Case vbKeyUp, vbKeyW
            blnUpDown = True
        Case vbKeyDown, vbKeyS
            blnDownDown = True
    End Select
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyLeft, vbKeyA
            blnLeftDown = False
        Case vbKeyRight, vbKeyD
            blnRightDown = False
        Case vbKeyUp, vbKeyW
            blnUpDown = False
        Case vbKeyDown, vbKeyS
            blnDownDown = False
    End Select
End Sub

Private Sub Form_Load()
    Dim strMap As String
    Dim strLine As String, strFileData As String
    Randomize
    strMessage = "Follow the Yellow Brick Road"
    dblLastMessage = Timer
    intLastMessage = 4
    On Error Resume Next
    strMap = "333333313333333333333333:" & _
             "3DDDDDD1DDDEEEEEDDEEEED3:" & _
             "3DEEEEE1EEEED1DEEEEDDED3:" & _
             "3DED1DEEED11111111111ED3:" & _
             "3DEE1DDDDD12282211111ED3:" & _
             "3DDE11111118BBB811111ED3:" & _
             "11DEDDDDFF12BGBFFF111ED3:" & _
             "11DEEEED1F18BBB81F111ED3:" & _
             "11DDDDED1F1228221F111ED3:" & _
             "11111DED1F1111111F111ED3:" & _
             "3DDDDDED1F11111FFF11EE11:" & _
             "3EEEEEED1FFFFF1F111EE111:" & _
             "3ED1111111111FFF11EE1111:" & _
             "3EDFFF1FFFFF11111EE11111:" & _
             "3ED11F1F111F111DDE11FFF1:" & _
             "3ED1FF1F128F821DEE1FF1F1:" & _
             "3ED1F11F12BBB21DED1F11F1:" & _
             "3EE1FFFF18BGB81DEDFF1FF1:" & _
             "3DE1111112BBB21DED111F11:" & _
             "3DEDDDDD1282821DED128F82:" & _
             "3DEDEEED1111111DED12BBB2:" & _
             "3DEEEDEEEEDDDDEEED18BGB8:" & _
             "3DDDDDDDDEEEEEEDDD12BBB2:" & _
             "333333333333333333328282"
    ReDim worldMap(UBound(Split(strMap, ":")) + 1, UBound(Split(strMap, ":")) + 1)
    Dim A As Integer, B As Integer
    Dim strMapPiece As String
    For A = 0 To UBound(Split(strMap, ":"))
        strMapPiece = Split(strMap, ":")(A)
        For B = 1 To Len(strMapPiece)
            If Val(Mid(strMapPiece, B, 1)) = 0 Then
                worldMap(A, B - 1) = (Asc("A") - Asc(Mid(strMapPiece, B, 1))) - 1
            Else
                worldMap(A, B - 1) = Mid(strMapPiece, B, 1)
            End If
        Next
    Next
    Randomize
    Dim I As Integer, D As Single, C As Integer, T As Single, S As Single, Q As Single
    Dim dblTime As Double
    X = 250
    Y = 250
    ScaleMode = vbTwips
    Width = (640 * Screen.TwipsPerPixelX) + (Width - ScaleWidth)
    Height = (480 * Screen.TwipsPerPixelY) + (Height - ScaleHeight)
    ScaleMode = vbPixels
    Show
    Dim K As Integer, L As Integer
    Dim intMove As Integer
    Dim dblSinQ As Single, dblCosQ As Single
    Do
        dblTime = Timer
        If intObtained < 3 Then
            Select Case Abs(worldMap(Int(X / 100), Int(Y / 100)))
                Case 0: ForeColor = vbBlack
                Case 1: ForeColor = vbRed
                Case 2: ForeColor = vbWhite
                Case 3: ForeColor = vbGreen
                Case 4: ForeColor = vbBlue
                Case 5: ForeColor = vbYellow
                Case 6: ForeColor = vbCyan
                Case 7: ForeColor = vbMagenta
                Case 8: ForeColor = vbBlack
            End Select
            Line (0, 0)-(ScaleWidth, 480), , BF
            For I = 0 To 63
                C = 0
                T = X
                S = Y
                Q = D + (I * 0.0174532925) + -0.5585
                K = Int(T / 100)
                L = Int(S / 100)
                dblSinQ = Sin(Q)
                dblCosQ = Cos(Q)
                While worldMap(K, L) < 0
                    C = C + 1
                    T = T + dblSinQ
                    S = S + dblCosQ
                    If Int(T / 100) <> K Then
                        K = Int(T / 100)
                        DrawLine I, C, worldMap(K, Int(S / 100))
                    End If
                    If Int(S / 100) <> L Then
                        L = Int(S / 100)
                        DrawLine I, C, worldMap(Int(T / 100), L)
                    End If
                Wend
            Next I
            intMove = (Timer - dblTime) * 300
            If blnUpDown Then
                If worldMap(Int((X + Sin(D) * intMove) / 100), Int((Y + Cos(D) * intMove) / 100)) <= 0 Then
                    X = X + Sin(D) * intMove
                    Y = Y + Cos(D) * intMove
                End If
            End If
            If blnDownDown Then
                If worldMap(Int((X - Sin(D) * intMove) / 100), Int((Y - Cos(D) * intMove) / 100)) <= 0 Then
                    X = X - Sin(D) * intMove
                    Y = Y - Cos(D) * intMove
                End If
            End If
            If blnLeftDown Then D = D - (intMove / 100)
            If blnRightDown Then D = D + (intMove / 100)
            If worldMap(Int(X / 100), Int(Y / 100)) = -7 Then
                worldMap(Int(X / 100), Int(Y / 100)) = -2
                intObtained = intObtained + 1
                Select Case Int(10 * Rnd)
                    Case 0
                        strMessage = "No!! Are you crazy? Look what you did!"
                    Case 1
                        strMessage = "I'm so ashamed of you! You're destroying this place!"
                    Case 2
                        strMessage = "You'll end our world with your meddling!"
                    Case 3
                        strMessage = "Our beautiful world!! You are ruining it!"
                    Case 4
                        strMessage = "History will write about your terrible deeds!"
                    Case 5
                        strMessage = "Couldn't leave it alone, could you?! Look what you've done!"
                    Case 6
                        strMessage = "The world is crumbling apart and it's all your fault!"
                    Case 7
                        strMessage = "You'll pay for this, with your life!"
                    Case 8
                        strMessage = "We could have been happy, but you've ruined that!"
                    Case 9
                        strMessage = "You disobeyed me?! After all we've been through!"
                End Select
                If intObtained = 3 Then
                    strMessage = "I am your father."
                    tmrEnd = True
                End If
                intLastMessage = 9
            End If
            If intObtained = 2 Then
                For K = 0 To Int(10 * Rnd)
                    CurrentX = ScaleWidth * Rnd
                    Line (CurrentX, 0)-(CurrentX, ScaleHeight)
                Next
            End If
        Else
            BackColor = vbBlack
        End If
        ForeColor = vbBlack
        Line (0, 470 - TextHeight("X"))-(ScaleWidth, ScaleHeight), , BF
        ForeColor = vbWhite
        CurrentY = 474 - TextHeight("X")
        CurrentX = (ScaleWidth - TextWidth(strMessage)) / 2
        Print strMessage
        DoEvents
    Loop
    
End Sub

Private Sub DrawLine(ByVal X As Integer, ByVal C As Integer, ByVal intColour As Integer)
    Select Case Abs(intColour)
        Case 0: ForeColor = vbBlack
        Case 1: ForeColor = vbRed
        Case 2: ForeColor = vbWhite
        Case 3: ForeColor = vbGreen
        Case 4: ForeColor = vbBlue
        Case 5: ForeColor = vbYellow
        Case 6: ForeColor = vbCyan
        Case 7: ForeColor = vbMagenta
        Case 8: ForeColor = vbBlack
    End Select
    Dim Y As Integer, S As Integer
    Y = (10000 / C) / Cos(X * 0.014)
    S = Y * 2
    Y = 240 - Y
    X = X * 10
    If intObtained = 1 Then
        Y = Y + Int(16 * Rnd) + -4
        S = S + Int(8 * Rnd) + -4
    ElseIf intObtained > 1 Then
        Y = Y + Int(32 * Rnd) + -4
        S = S + Int(16 * Rnd) + -4
        If Int(2 * Rnd) = 1 Then
            X = X + 4 + Int(8 * Rnd)
        End If
        If ForeColor = vbYellow Then
            If Int(4 * Rnd) = 1 Then
                ForeColor = vbWhite
            End If
        End If
    End If
    Line (X, Y)-(X + 9, Y + S), , BF
    If intObtained = 0 Or (intObtained = 2 And Int(3 * Rnd) = 1) Then
        ForeColor = vbBlack
        Line (X, Y)-(X + 10, Y)
        Line (X, Y + S)-(X + 10, Y + S)
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    End
End Sub

Private Sub tmrEnd_Timer()
    End
End Sub

Private Sub tmrSayStuff_Timer()
    Dim intPlayerSquare As Integer
    intPlayerSquare = Abs(worldMap(Int(X / 100), Int(Y / 100)))
    If intPlayerSquare = 5 Then intPlayerSquare = 4
    If intPlayerSquare <> intLastMessage Or (Timer - dblLastMessage) > 4 Then
        Select Case Abs(worldMap(Int(X / 100), Int(Y / 100)))
            Case 4, 5
                Select Case Int(9 * Rnd)
                    Case 0
                        strMessage = "Keep following the yellow brick road."
                    Case 1
                        strMessage = "You are nearly at the end."
                    Case 2
                        strMessage = "You are doing well. I'm proud of you."
                    Case 3
                        strMessage = "Remember to stay on the yellow brick road."
                    Case 4
                        strMessage = "Only " & Int(20 * Rnd) + 10 & " miles to go."
                    Case 5
                        strMessage = "Just a little bit further."
                    Case 6
                        strMessage = "You'll be a hero when you reach the end of the road."
                    Case 7
                        strMessage = "When you reach the end, we will have cake."
                    Case 8
                        strMessage = "Everything will be okay, when you reach the end of the road."
                End Select
                intLastMessage = 4
                dblLastMessage = Timer
            Case 6
                If intLastMessage <> 9 Then
                    Select Case Int(9 * Rnd)
                        Case 0
                            strMessage = "Woah! Get back to the yellow brick road now!"
                        Case 1
                            strMessage = "Keep away from this place! Go back to safety."
                        Case 2
                            strMessage = "This place isn't safe. Turn back now!"
                        Case 3
                            strMessage = "What are you doing?! Go back to the yellow brick road!"
                        Case 4
                            strMessage = "You're not supposed to be here!"
                        Case 5
                            strMessage = "Please turn back. I'm begging you."
                        Case 6
                            strMessage = "There's nothing interesting down here."
                        Case 7
                            strMessage = "You don't need to go down here!"
                        Case 8
                            strMessage = "This is the path to failure! Turn back now."
                    End Select
                    intLastMessage = 6
                    dblLastMessage = Timer
                End If
            Case 2
                If intLastMessage <> 9 Then
                    Select Case Int(4 * Rnd)
                        Case 0
                            strMessage = "That thing is very dangerous! Don't go near it."
                        Case 1
                            strMessage = "Don't go near the pink squares!"
                        Case 2
                            strMessage = "That's not safe! Turn back now."
                        Case 3
                            strMessage = "Don't touch that! It's lethal."
                    End Select
                    intLastMessage = 2
                    dblLastMessage = Timer
                End If
        End Select
    End If
End Sub
